<template>
  <q-layout view="hHh lpR fFf">
    <q-header
      class="bg-header text-header"
      :elevated="!$q.dark.isActive"
      bordered
    >
      <q-toolbar class="row toolbar">
        <!-- Left Buttons -->
        <div class="col flex items-center">
          <q-btn
            flat
            dense
            round
            icon="menu"
            aria-label="Menu"
            class="q-mr-sm"
          >
            <q-menu>
              <q-list style="min-width: 100px">
                <q-item clickable v-close-popup @click="newProject">
                  <q-item-section>New Project</q-item-section>
                </q-item>
                <q-item clickable v-close-popup @click="importProject">
                  <q-item-section>Import Project</q-item-section>
                </q-item>
                <q-item clickable v-close-popup @click="exportProject">
                  <q-item-section>Export Project</q-item-section>
                </q-item>
                <!-- URL is usually too big for this to be useful :( -->
                <!--
                <q-item clickable v-close-popup @click="shareProject">
                  <q-item-section>Share Project</q-item-section>
                </q-item>
                -->
              </q-list>
            </q-menu>
          </q-btn>

          <img
            class="sidebar-logo"
            src="~assets/logo.svg"
            style="height: 30px;"
          />
          <span style="font-size:16px; display:inline-block; padding-left:10px;">IDE</span>
        </div>

        <!-- Right Buttons -->
        <div class="col text-right q-gutter-x-md">
          <q-btn-group flat>
            <q-btn
              type="a"
              href="https://chipnet.imaginary.cash/"
              target="_blank"
              icon="img:img/block-explorer.png"
            >
              <q-tooltip>Chipnet Block Explorer</q-tooltip>
            </q-btn>

            <q-btn
              type="a"
              href="https://frolicking-pothos-d1aefc.netlify.app/"
              target="_blank"
              icon="img:img/cashonize-icon.png"
            >
              <q-tooltip>Cashonize (w/ CashRPC Support)</q-tooltip>
            </q-btn>

            <q-btn
              icon="img:img/git-icon.png"
            >
              <q-tooltip>Git Links</q-tooltip>
              <q-menu>
                <q-list style="min-width: 100px">
                  <q-item clickable v-close-popup type="a" href="https://github.com/jimtendo/cashonize-wc2/tree/wclib" target="_blank">
                    <q-item-section>Cashonize Fork (GitHub)</q-item-section>
                  </q-item>
                  <q-item clickable v-close-popup type="a" href="https://gitlab.com/developers.cash/cashconnect-js" target="_blank">
                    <q-item-section>CashConnect (GitLab)</q-item-section>
                  </q-item>
                  <q-item clickable v-close-popup type="a" href="https://gitlab.com/developers.cash/cashrpc-ide" target="_blank">
                    <q-item-section>CashRPC - IDE (GitLab)</q-item-section>
                  </q-item>
                </q-list>
              </q-menu>
            </q-btn>
          </q-btn-group>
        </div>
      </q-toolbar>
    </q-header>

    <!-- NOTE: "mobile" behavior will make the drawer close when user clicks outside it. -->
    <q-drawer
      v-model="reactives.leftDrawerOpen"
      class="column justify-between no-wrap sidebar"
      :elevated="!$q.dark.isActive"
      behavior="desktop"
      bordered
    >
      <!-- Top Menu Items -->
      <div>
        <q-list>
          <!-- Project -->
          <q-item clickable to="/">
            <q-item-section>
              <q-item-label header>{{ app.project.value.name }}</q-item-label>
            </q-item-section>
            <q-item-section side>
              <q-icon class="cursor-pointer" name="settings" />
            </q-item-section>
          </q-item>

          <q-separator />

          <!-- Contracts -->
          <q-item>
            <q-item-section>
              <q-item-label header>
              Contracts
              </q-item-label>
            </q-item-section>
            <q-item-section side>
              <q-icon class="cursor-pointer" name="add">
                <q-menu>
                  <q-list style="min-width: 100px">
                    <q-item clickable v-close-popup @click="newContract">
                      <q-item-section>New</q-item-section>
                    </q-item>
                    <q-item clickable v-close-popup @click="importContracts">
                      <q-item-section>Import</q-item-section>
                    </q-item>
                  </q-list>
                </q-menu>
              </q-icon>
            </q-item-section>
            <!--
            <q-item-section side>
              <q-icon class="cursor-pointer" name="upload" @click="triggerFilePicker()" />
            </q-item-section>
            <q-item-section side>
              <q-icon class="cursor-pointer" name="create" @click="triggerFilePicker()" />
            </q-item-section>
            -->
          </q-item>

          <q-item v-for="(contract, i) of app.project.value.contracts" :key="i" clickable :to="`/contract/${i}`">
            <q-item-section avatar>
              <q-icon name="source" />
            </q-item-section>

            <q-item-section>
              <q-item-label>{{ contract.name }}</q-item-label>
            </q-item-section>

            <q-item-section side>
              <q-icon v-if="!contract.artifact" name="error" color="warning" />
              <q-icon v-else name="check" />
            </q-item-section>
          </q-item>

          <!-- Template -->
          <q-item>
            <q-item-section>
              <q-item-label header>Template</q-item-label>
            </q-item-section>
          </q-item>

          <q-item clickable to="/generate">
            <q-item-section avatar>
              <q-icon name="data_object" />
            </q-item-section>

            <q-item-section>
              <q-item-label>Generate</q-item-label>
            </q-item-section>

            <q-item-section side>
              <q-icon v-if="app.project.value.template.error" name="error" color="warning" />
              <q-icon v-else name="check" />
            </q-item-section>
          </q-item>

          <!-- Tests -->
          <q-separator />
            <q-item clickable>
              <q-item-section>
                <q-item-label header>Tests</q-item-label>
              </q-item-section>
              <q-item-section side>
                <q-icon class="cursor-pointer" name="add">
                  <q-menu>
                    <q-list style="min-width: 100px">
                      <q-item clickable v-close-popup @click="addTest(template_GetBalanceV0)">
                        <q-item-section>bch_getBalance_V0</q-item-section>
                      </q-item>
                      <q-item clickable v-close-popup @click="addTest(template_GetChangeLockingBytecodeV0)">
                        <q-item-section>bch_getChangeLockingBytecode_V0</q-item-section>
                      </q-item>
                      <q-item clickable v-close-popup @click="addTest(template_GetTokensV0)">
                        <q-item-section>bch_getTokens_V0</q-item-section>
                      </q-item>
                      <q-item clickable v-close-popup @click="addTest(template_SignMessageV0)">
                        <q-item-section>bch_signMessage_V0</q-item-section>
                      </q-item>
                      <q-item clickable v-close-popup @click="addTest(template_SignTransactionV0)">
                        <q-item-section>bch_signTransaction_V0</q-item-section>
                      </q-item>
                    </q-list>
                  </q-menu>
                </q-icon>
              </q-item-section>
            </q-item>
          <q-separator />

          <!-- Wallet Connect Settings -->
          <q-item to="/wallet-connect">
            <q-item-section avatar>
              <q-icon name="settings" />
            </q-item-section>
            <q-item-section>
              <q-item-label>Session</q-item-label>
            </q-item-section>
          </q-item>

          <!-- Tests -->
          <q-item v-for="(test, j) of app.project.value.tests" :key="j" :to="`/test/${j}`">
            <q-item-section avatar>
              <q-icon name="arrow_forward" />
            </q-item-section>
            <q-item-section>
              <q-item-label>{{ test.name }}</q-item-label>
            </q-item-section>
          </q-item>
        </q-list>
      </div>
    </q-drawer>

    <q-drawer v-model="app.help.value.active" side="right" :width="600" bordered>
      <q-toolbar>
        <q-space />
        <q-btn icon="close" @click="app.help.value.active = false" flat />
      </q-toolbar>
      <div class="q-pa-lg" v-html="app.help.value.content"></div>
    </q-drawer>

    <q-page-container>
      <router-view v-slot="{ Component }" :key="$route.fullPath">
        <transition appear enter-active-class="animated fadeIn slower">
          <Suspense @pending="$q.loading.show()" @resolve="$q.loading.hide()">
            <component :is="Component" />
          </Suspense>
        </transition>
      </router-view>
    </q-page-container>

    <q-file
      ref="filePicker"
      style="display:none"
      v-model="reactives.files"
      @update:model-value="importContracts"
      accept=".cash"
      outlined
      multiple
    />
  </q-layout>
</template>

<script setup lang="ts">
import { reactive, ref } from 'vue';
import { useRoute } from 'vue-router';
import { useQuasar, exportFile } from 'quasar';

// Service Singleton.
import { app } from '../boot/app';

import { pickFiles } from '../utils/misc.js';

// Templates (Project)
import template_ProjectDefault from '../templates/project_default.json';

// Templates (Contract)
import template_ContractDefault from '../templates/contract_default.txt?raw';

// Templates (RPC)
import template_GetBalanceV0 from '../templates/bch_getBalance_V0.js';
import template_GetChangeLockingBytecodeV0 from '../templates/bch_getChangeLockingBytecode_V0.js';
import template_GetTokensV0 from '../templates/bch_getTokens_V0.js';
import template_SignMessageV0 from '../templates/bch_signMessage_V0.js';
import template_SignTransactionV0 from '../templates/bch_signTransaction_V0.js';

// Components.
import { Project, Test } from 'src/types';

// Framework
const $q = useQuasar();
const $route = useRoute();

//-----------------------------------------------------------------------------
// State
//-----------------------------------------------------------------------------

const filePicker = ref();

const reactives = reactive({
  leftDrawerOpen: true as boolean,
  rightDrawerOpen: true as boolean,
  files: [],
});
//-----------------------------------------------------------------------------
// Methods
//-----------------------------------------------------------------------------

async function newProject() {
  // Disconnect the current Wallet Connect session.
  if(app.walletConnect.isPaired.value) {
    app.walletConnect.disconnect();
  }

  app.project.value = template_ProjectDefault as Project;
}

async function importProject() {
  const files = await pickFiles(false);

  if(files.length !== 1) {
    throw new Error('Invalid file selected');
  }

  // Disconnect the current Wallet Connect session.
  if(app.walletConnect.isPaired.value) {
    app.walletConnect.disconnect();
  }

  // Set our project.
  app.project.value = JSON.parse(files[0].content);
}

async function exportProject() {
  const filename = `${app.project.value.name}.json`;
  const contents = JSON.stringify(app.project.value, null, 2);

  const status = exportFile(filename, contents);

  if (status !== true) {
    $q.notify({
      message: 'Browser disallowed file download'
    });
  }
}

async function shareProject() {
  // NOTE: This is unused.
  //       Browsers have a limit on URL length and the constructed string will usually be too long.

  // Stringify the project.
  const stringifiedProject = JSON.stringify(app.project.value);

  // Base64 the project.
  const base64Project = btoa(stringifiedProject);

  // Get the domain.
  const baseUrl = `${window.location.protocol}//${window.location.hostname}:${window.location.port}`;

  // Share URL
  const shareUrl = new URL(`${baseUrl}/#/?project=${base64Project}`).toString();

  console.log(shareUrl);
}

function newContract() {
  app.project.value.contracts.push({
    name: 'Example',
    source: template_ContractDefault
  });
}

async function importContracts() {
  const files = await pickFiles(true);

  for (const file of files) {
    const contract = {
      name: file.name,
      source: file.content,
    }

    app.compileContract(contract);

    app.project.value.contracts.push(contract);
  }
}

function addTest(template: Test): void {
  // We have to make a copy, otherwise we will mutate the template we imported.
  const templateCopy = JSON.parse(JSON.stringify(template));

  // Add it to our list of tests for this signer.
  app.project.value.tests.push(templateCopy);
}
</script>

<style lang="scss">
.sidebar {
  background: var(--background-primary);
  overflow-y: hidden;
}

/* Title styling */
.q-toolbar__title {
  font-size: 0.9rem;
  font-family: sans-serif;
  text-transform: uppercase;
}

/* Menu Item Styling */
.q-item__section--avatar {
  min-width: 44px;
}

.q-item__label {
  font-size: 16px;
}

.q-item__label--header {
  line-height: 13px;
  font-size: 13px;
  font-weight: bold;
  padding: 5px;
  padding-left: 0px;
  text-transform: uppercase;
}

.q-item__label.text-caption {
  color: var(--text-muted);
  text-transform: none;
}
</style>
